#!/usr/bin/perl

# -
# - dcplanet.pl rewrited
# - ver 0.6
# -
# Автор, судя по всему, akam
# небольшие доработки - Мара, b00
#
# 10.03.2010, b00
# 1. Внесены изменения в шаблон парсинга фрейма планеты (в связи с появлением строки "государство"):
# - корректно распознаётся владелец планеты
# - распознаётся государство, на чьей территории расположена планета
# - информация о государстве выводится на печать
# 2. Добавлен индикатор процесса парсинга известных планет.
# 3. Кодировка скрипта и вывода изменена на utf8

#use Strict;
use LWP::UserAgent;
use HTTP::Cookies;
use utf8;
$| = 1;

# ---------------------------------------------------------------------------
my $url='http://www.the-game.ru';

my $confile="dcplanet.rc";
my @users;
my $browser = LWP::UserAgent->new();;
my @FrameCoords;
my $CurrentUser;

# ---------------------------------------------------------------------------


# ---------------------------------------------------------------------------
# - Functions block -

sub ReadConfig {
# Read config file and put data to massive hash $users
# example: $users{'akam'}
    my $op="";
    my $login;
    my $pass;
    my $up;
    my $down;

    
    open(CONFIG, "< $confile") or die ("Cannot open configuration file: $!");
    while (<CONFIG>) {
        chomp;               # Убрать перевод строки
        s/#.*//;             # Убрать комментарии
        s/^\s+//;            # Убрать начальные пропуски
        s/\s+$//;            # Убрать конечные пропуски
        next unless length;  # Что-нибудь осталось?
        if (/\[Config\]/) { $op="config"; next; }
        if (/\[Users\]/) { $op="users"; next; }
        if($op eq "config") {
            my($var, $value) = split(/\s*=\s*/, $_, 2);
            no strict 'refs';
            $$var = $value;
        } elsif($op eq "users") {
	    my ($login,$pass,$up,$down) = split(/\s*;\s*/);
	    push (@users, "$login,$pass,$up,$down");
        } else {
	    print "Configuration file handled ok\n";
	}
    }
    close(CONFIG);
}

sub FirstAuth($$) {
# Auth on the site
# Firstauth(login,password)
    $browser->cookie_jar( HTTP::Cookies->new('file' => 'cookies.lwp','autosave' => 0));
    $browser->agent('Mozilla');
    push @{ $browser->requests_redirectable }, 'POST';
    
    my $response = $browser->post( $url.'/overview/' ,
    [
	'action' => 'login',
	'login' => @_[0],
	'pwd' => @_[1],
    ]);
    if($response->content =~ /<input/) { die("Invalid user @_[0] and/or password. Please check this manually.\nScript interrupt.\n"); }
    #<title>D&amp;C :: Разделяй и властвуй :: akam</title>
    if($response->content =~ /.+?::.+?::\s(.*)<\/title>/) { $CurrentUser=$1; }
    print "User @_[0] logged in us player $CurrentUser\n";
}

sub LogOff() {
    my $LogoffURI="http://www.the-game.ru/logoff/";
    my $response = $browser->get($LogoffURI);
    if($response->content =~ /<input/) { print "User $CurrentUser logged off\n"; $CurrentUser=""; }
}

sub GetScreenList($$) {
# Create fleet frame list array
# GetScreenList(up coord,down coord)
    @FrameCoords=();
    (my $sX, my $sY)=split(/:/,@_[0]);
    (my $eX, my $eY)=split(/:/,@_[1]);
    my $X;my $Y;
    my $total=($eX-$sX)*($eY-$sY);

    for ($X=$sX+8; $X<=$eX; $X=$X+15) {
      for ($Y=$sY+8; $Y<=$eY; $Y=$Y+15) {
         push (@FrameCoords,"$X:$Y");
      }
    }
    print "Start point: @_[0]\tEnd point: @_[1]\n";
    print "Total planets on this perimeter: $total\n";
}

sub GetFleetFrameSource($) {
# Get Fleet frame html source code
# GetFleetFrameSource("500:500");
    my $FleetFrame="http://www.the-game.ru/frames/skymap/on/army/?planetid=";
    my $response = $browser->get("${FleetFrame}@_");
    my $FleetFrameSource = $response->content;
      die "$!\n" unless $response->is_success;
    return $FleetFrameSource;
}

sub GetPlanetFrameSource($) {
# Get Planet frame html source code
# GetPlanetFrameSource(500:500)
    my $PlanetFrame="http://www.the-game.ru/frames/planetinfo/on/planet/?planetid=";
    my $response = $browser->get("${PlanetFrame}@_");
    my $PlanetFrameSource = $response->content;
    return $PlanetFrameSource;
}

sub GetKnownPlanets($) {
# Get known planets list from Fleet frame
# GetKnownPlanets($FleetFrameSource)
    my $FleetFrameSource = shift;
    my @KnownPlanets=();
    for ($FleetFrameSource =~ m#navplanet_perimeter.+?/\?planetid=(\d{1,4}:\d{1,4})#gsc) {
        push(@KnownPlanets,"$_");
    }
    return @KnownPlanets;
}

sub GetPlanetData($) {
# Get planet data from planet frame
# GetPlanetData($PlanetFrameSource)
    my $PlanetFrameSource = shift;
    my($x,$y)=split(/:/);
    $PlanetFrameSource=~m{<td class=\"graphval\">(\d{1,2}).+?<td class=\"graphval\">(\d{1,2}).+?<td class=\"graphval\">(\d{1,2}).+?<td class=\"graphval\">(\d{1,2}).+?<td class=\"graphval\">(\d{1,2}).+?alt=\"Planet\s(.+?)\"}gcs;
    my($O,$E,$M,$T,$S,$planetname)=($1,$2,$3,$4,$5,$6);
    if($PlanetFrameSource=~m{playerinfo.+?\)">(.+?)</a>}gsc) { $owner=$1; }
        elsif ( $PlanetFrameSource=~m{<input name="newname"}gsc ) { $owner = $CurrentUser; }
        else { $owner=""; }

    if($PlanetFrameSource=~m{playerinfo.+?target="_top">(.+?)</a>}gsc) { $state=$1; } else { $state=""; }
    #if($PlanetFrameSource=~m/sim_table/gsc) { $owner=$CurrentUser; }
    return "$x;$y;$O;$E;$M;$T;$S;$planetname;$owner;$state\n";
}

# - End of functions block -
# --------------------------------------------------------------------------
############################################################################
# --------------------------------------------------------------------------
# - Main programm -

ReadConfig;
foreach(@users) {
    my @KnownPlanets=();
#    my @PlanetData=();
    ($login,$pass,$up,$down)=split(/,/);
    FirstAuth($login,$pass);
    next if($ARGV[0] eq "--pingonly");
    GetScreenList($up,$down);
    print "Creating known planets array...\n";
    foreach(@FrameCoords) {
	push(@KnownPlanets,GetKnownPlanets(GetFleetFrameSource($_)));
    }
    print "Known planets: " . ($#KnownPlanets+1) . "\n" . 'Process';
    foreach(@KnownPlanets) {
        print '.';
        push(@PlanetData,GetPlanetData(GetPlanetFrameSource($_)));
    }
    print "\nDone\n";
    LogOff();
}
if($ARGV[0] ne "--pingonly") {
    open(CSV,">DCout.csv");
    print CSV "X;Y;O;E;M;T;S;PlanetName;Owner;State\n";
    foreach(@PlanetData) { print CSV; }
}

__END__
